package org.openoffice.sdk.example.spreadsheet;

import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XComponentContext;
import com.sun.star.lib.uno.helper.Factory;
import com.sun.star.lang.XSingleComponentFactory;
import com.sun.star.registry.XRegistryKey;
import com.sun.star.lib.uno.helper.WeakBase;


public final class CalcAddinImpl extends WeakBase
   implements com.sun.star.lang.XServiceInfo,
              com.sun.star.sheet.XCompatibilityNames,
              org.openoffice.sdk.example.spreadsheet.XCalcAddin,
              com.sun.star.sheet.XAddIn,
              com.sun.star.lang.XServiceName
{
    private final XComponentContext m_xContext;
    private static final String m_implementationName = CalcAddinImpl.class.getName();
    private static final String[] m_serviceNames = {
        "org.openoffice.sdk.example.spreadsheet.CalcAddin",
        "com.sun.star.sheet.AddIn" };

    private com.sun.star.lang.Locale m_locale = new com.sun.star.lang.Locale();

    private static final String sADDIN_SERVICENAME = "org.openoffice.sdk.example.spreadsheet.CalcAddin";

    private static final String sDISPLAYNAME = "DisplayName";
    private static final String sDESCRIPTION = "Description";
    private static final String sCATEGORY = "Category";
    private static final String sCATEGORYDISPLAYNAME = "CategoryDisplayName";

    private com.sun.star.container.XHierarchicalNameAccess  m_xHAccess = null;
    private com.sun.star.container.XHierarchicalNameAccess  m_xCompAccess = null;
    private java.util.Hashtable<
        String, java.util.Hashtable< Integer, String> > m_functionMap = null;


    public CalcAddinImpl( XComponentContext context )
    {
        m_xContext = context;

        try {
        m_functionMap = new java.util.Hashtable<
            String, java.util.Hashtable< Integer, String > >();

        java.util.Hashtable< Integer, String > fpm = new java.util.Hashtable< Integer, String >();
        fpm.put(0, "xOptions");
        m_functionMap.put("getMyFirstValue", fpm);

        fpm = new java.util.Hashtable< Integer, String >();
        fpm.put(0, "xOptions");
        fpm.put(1, "intDummy");
        m_functionMap.put("getMySecondValue", fpm);

        com.sun.star.lang.XMultiServiceFactory xProvider = 
            (com.sun.star.lang.XMultiServiceFactory)UnoRuntime.queryInterface(
                com.sun.star.lang.XMultiServiceFactory.class,
                m_xContext.getServiceManager().createInstanceWithContext(
                    "com.sun.star.configuration.ConfigurationProvider",
                    m_xContext));

        String sReadOnlyView = "com.sun.star.configuration.ConfigurationAccess";

        StringBuffer sPath = new StringBuffer(
             "/org.openoffice.Office.CalcAddIns/AddInInfo/");
        sPath.append(sADDIN_SERVICENAME);
        sPath.append("/AddInFunctions");

        // create arguments: nodepath
         com.sun.star.beans.PropertyValue aArgument = 
             new com.sun.star.beans.PropertyValue();
         aArgument.Name = "nodepath";
         aArgument.Value = new com.sun.star.uno.Any(
             com.sun.star.uno.Type.STRING, sPath.toString());

        Object aArguments[] = new Object[1];
        aArguments[0] = new com.sun.star.uno.Any( new com.sun.star.uno.Type(
            com.sun.star.beans.PropertyValue.class), aArgument);

        // create the default view using default UI locale
         Object xIface = 
             xProvider.createInstanceWithArguments(sReadOnlyView, aArguments);

        m_xHAccess = (com.sun.star.container.XHierarchicalNameAccess)
             UnoRuntime.queryInterface(
                 com.sun.star.container.XHierarchicalNameAccess.class, xIface);

        // extends arguments to create a view for all locales to get simple
        // access to the compatibilityname property
        aArguments = new Object[2];
        aArguments[0] = new com.sun.star.uno.Any( new com.sun.star.uno.Type(
            com.sun.star.beans.PropertyValue.class), aArgument);
        aArgument.Name = "locale";
        aArgument.Value = new com.sun.star.uno.Any(
            com.sun.star.uno.Type.STRING, "*");
        aArguments[1] = new com.sun.star.uno.Any(  new com.sun.star.uno.Type(
            com.sun.star.beans.PropertyValue.class), aArgument);

        // create view for all locales
        xIface = xProvider.createInstanceWithArguments(sReadOnlyView, aArguments);

        m_xCompAccess = (com.sun.star.container.XHierarchicalNameAccess)
            UnoRuntime.queryInterface(
                com.sun.star.container.XHierarchicalNameAccess.class, xIface);
        }
        catch ( com.sun.star.uno.Exception e ) {
        }
    }

    // addin configuration property helper function:
    String getAddinProperty(String funcName, String paramName, String propName)
    {
        try {
            StringBuffer buf = new StringBuffer(funcName);

            if (paramName.length() > 0) {
                buf.append("/Parameters/");
                buf.append(paramName);
            }

            com.sun.star.beans.XPropertySet xPropSet =
                (com.sun.star.beans.XPropertySet)UnoRuntime.queryInterface(
                    com.sun.star.beans.XPropertySet.class,
                    m_xHAccess.getByHierarchicalName(buf.toString()));

            return com.sun.star.uno.AnyConverter.toString(
                xPropSet.getPropertyValue(propName));
        }
        catch ( com.sun.star.uno.RuntimeException e ) {
            throw e;
        }
        catch ( com.sun.star.uno.Exception e ) {
        }
        return "";
    }

    public static XSingleComponentFactory __getComponentFactory( String sImplementationName ) {
        XSingleComponentFactory xFactory = null;

        if ( sImplementationName.equals( m_implementationName ) )
            xFactory = Factory.createComponentFactory(CalcAddinImpl.class, m_serviceNames);
        return xFactory;
    }

    public static boolean __writeRegistryServiceInfo( XRegistryKey xRegistryKey ) {
        return Factory.writeRegistryServiceInfo(m_implementationName,
                                                m_serviceNames,
                                                xRegistryKey);
    }

    // com.sun.star.lang.XServiceInfo:
    public String getImplementationName() {
         return m_implementationName;
    }

    public boolean supportsService( String sService ) {
        int len = m_serviceNames.length;

        for( int i=0; i < len; i++) {
            if (sService.equals(m_serviceNames[i]))
                return true;
        }
        return false;
    }

    public String[] getSupportedServiceNames() {
        return m_serviceNames;
    }

    // com.sun.star.sheet.XCompatibilityNames:
    public com.sun.star.sheet.LocalizedName[] getCompatibilityNames(String aProgrammaticName)
    {
        com.sun.star.sheet.LocalizedName[] seqLocalizedNames =
            new com.sun.star.sheet.LocalizedName[0];

        try {
            StringBuffer path = new StringBuffer(aProgrammaticName);
            path.append("/CompatibilityName");
            String hname = path.toString();

            if ( m_xCompAccess.hasByHierarchicalName(hname) ) {
                com.sun.star.container.XNameAccess xNameAccess =
                    (com.sun.star.container.XNameAccess)UnoRuntime.queryInterface(
                        com.sun.star.container.XNameAccess.class,
                        m_xCompAccess.getByHierarchicalName(hname));

                String elems[] = xNameAccess.getElementNames();
                int len = elems.length;
                seqLocalizedNames = new com.sun.star.sheet.LocalizedName[len];
                String sCompatibilityName = "";

                for (int i=0; i < len; ++i) {
                    String sLocale = elems[i];
                    sCompatibilityName = com.sun.star.uno.AnyConverter.toString(
                        xNameAccess.getByName(sLocale));

                    com.sun.star.lang.Locale aLocale = 
                        new com.sun.star.lang.Locale();

                    String tokens[] = sLocale.split("-");
                    int nToken = tokens.length;
                    if (nToken >= 1) aLocale.Language = tokens[0];
                    if (nToken >= 2) aLocale.Country = tokens[1];
                    if (nToken >= 3)  {
                        StringBuffer buf = 
                            new StringBuffer(tokens[2]);
                        for (int t=3; t < nToken; ++t)
                            buf.append(tokens[t]);

                        aLocale.Variant = buf.toString();
                    }

                    seqLocalizedNames[i].Locale = aLocale;
                    seqLocalizedNames[i].Name = sCompatibilityName;
                }
        }
        }
        catch ( com.sun.star.uno.RuntimeException e ) {
            throw e;
        }
        catch ( com.sun.star.uno.Exception e ) {
        }

        return seqLocalizedNames;
    }

    // org.openoffice.sdk.example.spreadsheet.XCalcAddin:
    public int getMyFirstValue(com.sun.star.beans.XPropertySet xOptions)
    {
        // TODO: Exchange the default return implementation for "getMyFirstValue" !!!
        // NOTE: Default initialized polymorphic structs can cause problems
        // because of missing default initialization of primitive types of
        // some C++ compilers or different Any initialization in Java and C++
        // polymorphic structs.
        return (int) 1;
    }

    public int getMySecondValue(com.sun.star.beans.XPropertySet xOptions, int intDummy)
    {
        // TODO: Exchange the default return implementation for "getMySecondValue" !!!
        // NOTE: Default initialized polymorphic structs can cause problems
        // because of missing default initialization of primitive types of
        // some C++ compilers or different Any initialization in Java and C++
        // polymorphic structs.
        return ((int) 2 + intDummy);
    }

    // com.sun.star.sheet.XAddIn:
    public String getProgrammaticFuntionName(String aDisplayName)
    {
        try {
            com.sun.star.container.XNameAccess xNAccess =
                (com.sun.star.container.XNameAccess)UnoRuntime.queryInterface(
                    com.sun.star.container.XNameAccess.class, m_xHAccess);
            String functions[] = xNAccess.getElementNames();
            String sDisplayName = "";
            int len = functions.length;
            for (int i=0; i < len; ++i) {
                sDisplayName = com.sun.star.uno.AnyConverter.toString(
                    getAddinProperty(functions[i], "", sDISPLAYNAME));
                if (sDisplayName.equals(aDisplayName))
                    return functions[i];
            }
        }
        catch ( com.sun.star.uno.RuntimeException e ) {
            throw e;
        }
        catch ( com.sun.star.uno.Exception e ) {
        }

        return "";
    }

    public String getDisplayFunctionName(String aProgrammaticName)
    {
        return getAddinProperty(aProgrammaticName, "", sDISPLAYNAME);
    }

    public String getFunctionDescription(String aProgrammaticName)
    {
        return getAddinProperty(aProgrammaticName, "", sDESCRIPTION);
    }

    public String getDisplayArgumentName(String aProgrammaticFunctionName, int nArgument)
    {
        return getAddinProperty(aProgrammaticFunctionName,
                                m_functionMap.get(
                                    aProgrammaticFunctionName).get(nArgument),
                                sDISPLAYNAME);
    }

    public String getArgumentDescription(String aProgrammaticFunctionName, int nArgument)
    {
        return getAddinProperty(aProgrammaticFunctionName,
                                m_functionMap.get(
                                    aProgrammaticFunctionName).get(nArgument),
                                sDESCRIPTION);
    }

    public String getProgrammaticCategoryName(String aProgrammaticFunctionName)
    {
        return getAddinProperty(aProgrammaticFunctionName, "", sCATEGORY);
    }

    public String getDisplayCategoryName(String aProgrammaticFunctionName)
    {
        return getAddinProperty(aProgrammaticFunctionName, "", sCATEGORYDISPLAYNAME);
    }

    // com.sun.star.lang.XLocalizable:
    public void setLocale(com.sun.star.lang.Locale eLocale)
    {
        m_locale = eLocale;
    }

    public com.sun.star.lang.Locale getLocale()
    {
        return m_locale;
    }

    // com.sun.star.lang.XServiceName:
    public String getServiceName() {
        return sADDIN_SERVICENAME;
    }
}
